import re

VirtualHostKeyEmptyMarker="XxXxXxXxXxXx"

isAFolderName=re.compile(r'^[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ][\w_]*$')
cleanPath=re.compile(r'(.+?)/?$')
isUsefulTemplate=re.compile(r'\\(\d|g)')
isIPAddress=re.compile(r'^[\d.]+$')
testURLMatch=re.compile(r'^(\w{3,6}://)?([\w_\.]+)(:\d+)?(/.*)?$')
marker=[]

def getErrorText(e):
    if type(e)==type(""): return [e]
    res=[]
    if hasattr(e,"args") and e.args:
        if e.args==type(""): res.append(e.args)
        else: res.extend(e.args)
    if hasattr(e,"text") and e.text:
        if e.text==type(""): res.append(e.text)
        else: res.extend(e.text)
    return res


class DictMimic: # ah, looking forward to Python 2.2...
    def __init__(self):
        self.dict={}
    def __len__(self):
        return len(self.dict)
    def __getitem__(self, key):
        return self.dict[key]
    def __setitem__(self, key, value):
        self.dict[key]=value
    def __delitem__(self, key):
        del self.dict[key]
    def __contains__(self, obj):
        return obj in self.dict.keys()
    def clear(self):
        self.dict.clear()
    def copy(self):
        newObj=self.__class__()
        newObj.dict=self.dict.copy()
        return newObj
    def has_key(self, k):
        return self.dict.has_key(k)
    def items(self):
        return self.dict.items()
    def keys(self):
        return self.dict.keys()
    def update(self, b):
        self.dict.update(b)
    def values(self):
        return self.dict.values()
    def get(self, k, v=None):
        return self.dict.get(k, v)
    def setdefault(self, k, v=None):
        return self.dict.setdefault(k, v)
    def popitem(self):
        return self.dict.popitem()

class RequestMimic(DictMimic):
    def __init__(self):
        self.dict={}
        self.protocol=self.host=self.port=""
    def setServerURL(self, protocol, host, port="8080"):
        self.dict["BASE0"]=protocol+"://"+host
        self.protocol=protocol
        self.host=host
        self.port=port
    set=DictMimic.__setitem__


def pathToBreadcrumbs(path, rootName="/", includeQueryString=0):
    """converts path to path plus links.  First element (root) will
    have name specified by rootName.  A query string in the last
    elementwill be completely removed from path and links if
    includeQueryString==0, and removed only in the path (but kept in
    the final link) if includeQueryString==1.  Any other value will
    keep the query string in both the path and the link."""

    #if includeQueryString == 0 and "?" in path[-1]:
    #    path[-1]=path[-1][:path[-1].index("?")]
    ret=[[rootName,""]]
    for i in range(1,len(path)):
        ret.append([path[i],ret[i-1][1]+"/"+path[i]])
    ret[0][1]="/"
    if ret[-1][0]=="index_html":
        ret.pop()
    if includeQueryString == 1 and "?" in ret[-1][0]: # what about index_html with query string?
        ret[-1][0]=ret[-1][0][:ret[-1][0].index("?")]
    return ret

